--=================================================================================
-- File:	Rogue Logic
-- Author:	 2005 Anavar
-- Description:	Rogue Target Logic
-- Some Code Borrowed / Used from:
-- 			DefendYourself
--			MezHelper	(thanks for your hard work!)
--=================================================================================

--=================================================================================
-- Variables


local Hold_Target = "NONE";
local COMBAT = "NO";
local SOLO_LOOP = "NO";
local LOOP_HOLD = "NONE";
local NEXT_LOOP_HOLD = "NONE";
local YES_SAP = "NO";
local STRIGGER = "NO";
local MYSAP = "NO";
local UNIT_PLAYER = "player";
local UNIT_TARGET = "target";
local BACKUP_ASSIST = "NONE";
local MAIN_ASSIST = "NONE";

-- local RogueLogic_NoAttack = {"Charm","Sap","Seduction","Sheep","Polymorph","Tame Beast","Scare Beast","Sleep","Hibernate","Fear","Mind Control","Freezing Trap Effect","Enslave Demon","Shackle Undead","Frost Trap","Reckless Charge","Dominate Mind","Frost Nova","Frostbite","Banish" };
local RogueLogic_NoAttack = {"Charm","Sap","Seduction","Sheep","Polymorph","Tame Beast","Scare Beast","Sleep","Hibernate","Mind Control","Freezing Trap Effect","Enslave Demon","Shackle Undead","Frost Trap","Reckless Charge","Dominate Mind","Banish" };


local EVENT_VARIABLES_LOADED = "VARIABLES_LOADED";
local EVENT_PLAYER_ENTER_COMBAT = "PLAYER_ENTER_COMBAT";
local EVENT_PLAYER_LEAVE_COMBAT = "PLAYER_LEAVE_COMBAT";
local EVENT_PLAYER_REGEN_ENABLED = "PLAYER_REGEN_ENABLED";
local EVENT_PLAYER_REGEN_DISABLED = "PLAYER_REGEN_DISABLED";
local EVENT_UNIT_AURA = "UNIT_AURA";

-- Returns a chat color code string
function RS_BCC(r, g, b)
	return string.format("|cff%02x%02x%02x", (r*255), (g*255), (b*255));
end

-- Standard colors to use
local RT = RS_BCC(1, 1, 0);
local YT = RS_BCC(1.0, 0.0, 0.0);

--=============================================================================

--=============================================================================

function RogueLogic_OnLoad()


 	-- Register for events

	this:RegisterEvent( EVENT_PLAYER_ENTER_COMBAT );
	this:RegisterEvent( EVENT_PLAYER_LEAVE_COMBAT );
	this:RegisterEvent( EVENT_PLAYER_REGEN_ENABLED );
	this:RegisterEvent( EVENT_PLAYER_REGEN_DISABLED );
	this:RegisterEvent( EVENT_UNIT_AURA );
	this:RegisterEvent( EVENT_VARIABLES_LOADED );

	-- Set the default text


	
	-- Slash Command Handler

	SLASH_RogueLogic1 = "/RogueLogic";
	SLASH_RogueLogic2 = "/rl";
	SlashCmdList["RogueLogic"] = function(msg)
		RogueLogic_SlashCommandHandler(msg);
	end

	-- Options Check (fill in the blanks)
	
	if RL_Debug == nil then RL_Debug = 0 ; end
	if RL_Attack == nil then RL_Attack = 0 ; end
	if RL_Channel == nil then RL_Channel = "auto" ; end
	if RL_AUTOTARGET == nil then RL_AUTOTARGET = 1 ; end
	if RL_Enabled == nil then RL_Enabled = 1 ; end
	if RL_Announce == nil then RL_Announce = 1 ; end
	if RL_MSG1 == nil then RL_MSG1 = "<<< Sapping" ; end
	if RL_MSG2 == nil then RL_MSG2 = ">>> Do Not Hit It" ; end

end

function RogueLogic_Target()


	if COMBAT == "YES" and UnitClass("player") == "Rogue" and RL_Enabled == 1 then

		if UnitName("target")~=nil and UnitIsEnemy("player","target") then
			
-- Find DeBuff In List?

			RogueLogicTip:ClearLines();
			
			for i = 1, getn(RogueLogic_NoAttack), 1 do
				for j = 1, 10, 1 do
					if (UnitDebuff("target",j)) then
						RogueLogicTip:SetUnitDebuff("target", j);
						local mg = RogueLogicTipTextLeft1:GetText();
						if (mg == RogueLogic_NoAttack[i]) then
--							if not (mg == LOOP_HOLD) then
							if not (mg == LOOP_HOLD) and not (mg == NEXT_LOOP_HOLD) then
								
								if LOOP_HOLD == "NONE" then
									LOOP_HOLD = mg;
								elseif not (LOOP_HOLD == "NONE") and NEXT_LOOP_HOLD == "NONE" then
									NEXT_LOOP_HOLD = mg;
								end
					
								if MYSAP == "YES" and RL_Announce == 1 then 
-- Announce SAP
									local mobnlevl = " " .. UnitName("target") .. " (" .. UnitLevel("target") .. ") ";
									
									if mg == "Sap" and UnitName("target")~=nil and (GetNumRaidMembers() > 0) and (RL_Channel == "auto" or RL_Channel == "raid") then
										SendChatMessage(RL_MSG1 .. mobnlevl .. RL_MSG2, "RAID");
										MYSAP = "NO";
										STRIGGER = "NO";
									elseif mg == "Sap" and UnitName("target")~=nil and (GetNumPartyMembers() > 0) and (RL_Channel == "auto" or RL_Channel == "party") then
										SendChatMessage(RL_MSG1 .. mobnlevl .. RL_MSG2, "PARTY");
										MYSAP = "NO";
										STRIGGER = "NO";
									elseif mg == "Sap" and UnitName("target")~=nil and RL_Channel == "auto" then
										if RL_Debug == 1 then DEFAULT_CHAT_FRAME:AddMessage(RL_MSG1 .. mobnlevl .. RL_MSG2, 1.0, 1.0, 0.0 ); end
										MYSAP = "NO";
										STRIGGER = "NO";
									elseif mg == "Sap" and UnitName("target")~=nil and RL_Channel == "say" then
										SendChatMessage(RL_MSG1 .. mobnlevl .. RL_MSG2, "SAY" );
										MYSAP = "NO";
										STRIGGER = "NO";
									end
									
								elseif MYSAP == "YES" and RL_Announce == 0 then
									MYSAP = "NO";
									STRIGGER = "NO";
								end
								
								DEFAULT_CHAT_FRAME:AddMessage(YT .. "Target DeBuff: " .. RT .. mg .. " on " .. UnitName("target") .. YT);
-- ReTarget if Option is selected								
								if RL_AUTOTARGET == 1 and GetComboPoints("Player") == 0 then								
									local myTarget = UnitName("target");
									local myTargetLevel = UnitLevel("target");
									local myTargetSex = UnitSex("target");
									TargetNearestEnemy();
									if (UnitName("target") == myTarget) and (UnitLevel("target") == myTargetLevel) and (myTargetSex == UnitSex("target")) then 
										TargetNearestEnemy();
										if RL_Debug == 1 then DEFAULT_CHAT_FRAME:AddMessage(YT .. "DeBuff Re-Target: "  .. RT .. UnitName("target") .. YT ); end
									end
									break;
								elseif RL_AUTOTARGET == 1 and GetComboPoints("Player") > 0 then								
									if RL_Debug == 1 then DEFAULT_CHAT_FRAME:AddMessage(YT .. "No Re-Target (Combo Points): "  .. RT .. UnitName("target") .. YT ); end
									break;
								end
								break;
							end
						end
					end
				
				end	
			end				
		end					

-- No Tareget? Get one...
			
			if  UnitName("target") == nil and GetComboPoints("Player") == 0 and RL_AUTOTARGET == 1 and SOLO_LOOP == "NO"  then			

						if GetNumPartyMembers() > 0 and not (MAIN_ASSIST == "NONE") then
							AssistByName(MAIN_ASSIST);
							if RL_Debug == 1 and not(UnitName("target") == nil) then DEFAULT_CHAT_FRAME:AddMessage(YT .. "Assisting: " .. RT .. MAIN_ASSIST .. YT ); end
							if (not (UnitAffectingCombat("target") == 1) and not (UnitName("target") == nil)) or UnitIsDead("target") then
								AssistByName(MAIN_ASSIST);
								if RL_Debug == 1 and not(UnitName("target") == nil) then DEFAULT_CHAT_FRAME:AddMessage(YT .. "Assisting [Retry]: " .. RT .. MAIN_ASSIST .. YT ); end
									if (not (UnitAffectingCombat("target") == 1) and not (UnitName("target") == nil)) or UnitIsDead("target") then
										TargetByName(MAIN_ASSIST);
										if UnitIsDead("target") then
											TargetNearestEnemy();
											DEFAULT_CHAT_FRAME:AddMessage(YT .. "Assist Died [Targeting Closest]: " .. RT .. UnitName("target") .. YT );
											SOLO_LOOP = "YES";
										end
									end
							end
							if RL_Attack == 1 and UnitAffectingCombat("target") == 1 and not (PlayerFrame.inCombat) then
--							if RL_Attack == 1 and UnitAffectingCombat("target") == 1 then
								AttackTarget();
								if RL_Debug == 1 then DEFAULT_CHAT_FRAME:AddMessage("Auto Attacking: " .. UnitName("target")); end
							end
						else						
							TargetNearestEnemy();
							if RL_Debug == 1 and not(UnitName("target") == nil) then DEFAULT_CHAT_FRAME:AddMessage(YT .. "New Target [1]: " .. RT .. UnitName("target") .. YT ); end
							if not (UnitAffectingCombat("target") == 1) and not(UnitName("target") == nil) and UnitAffectingCombat("player") == 1 then
								TargetNearestEnemy();
								if RL_Debug == 1 and not(UnitName("target") == nil) then DEFAULT_CHAT_FRAME:AddMessage(YT .. "New Target [2]: " .. RT .. UnitName("target") .. YT ); end
								if not (UnitAffectingCombat("target") == 1) and not(UnitName("target") == nil) then
									TargetNearestEnemy();
									if RL_Debug == 1 and not(UnitName("target") == nil) then DEFAULT_CHAT_FRAME:AddMessage(YT .. "New Target [3]: " .. RT .. UnitName("target") .. YT ); end
									if not (UnitAffectingCombat("target") == 1) and not(UnitName("target") == nil) then
										if RL_Debug == 1 then DEFAULT_CHAT_FRAME:AddMessage(YT .. "Gave Up Solo - No Hostile Targets!" .. RT ); end
										SOLO_LOOP = "YES";
										if GetNumPartyMembers() == 0 then ClearTarget(); end
									end
								end
							end
							if RL_Attack == 1 and UnitAffectingCombat("target") == 1 and not (PlayerFrame.inCombat) then
								AttackTarget();
								if RL_Debug == 1 then DEFAULT_CHAT_FRAME:AddMessage("Auto Attacking: " .. UnitName("target")); end
							end
						end
			end			
	end


end


function RogueLogic_Update( event, arg1, arg2 )

	if (event == "VARIABLES_LOADED") then
		if( DEFAULT_CHAT_FRAME ) then
			DEFAULT_CHAT_FRAME:AddMessage(YT .. "Rogue Logic! " .. RT .. "Type /roguelogic help or /rl help for commands" .. YT );
		end
	end

-- debug thingy
-- DEFAULT_CHAT_FRAME:AddMessage( event , 0.3, 1.0, 1.0 );	

	if UnitClass("player") == "Rogue" and RL_Enabled == 1 then

-- Pre SAP Check For Stealth

		if event == EVENT_UNIT_AURA and arg1 == UNIT_PLAYER then
		
					for i=1,GetNumShapeshiftForms(),1 do
						local _, name, isActive = GetShapeshiftFormInfo(i);
						if isActive then
							STRIGGER = "YES";
						else
							STRIGGER = "NO";
						end
					end

		end

		if event == EVENT_PLAYER_LEAVE_COMBAT and UnitIsEnemy("player","target") and STRIGGER == "YES" then
--			Only Triggers If You SAP a Target
			MYSAP = "YES";
			COMBAT = "YES";	
			RogueLogic_Target();	
		elseif event == EVENT_PLAYER_REGEN_ENABLED or (not(UnitAffectingCombat("player") == 1) and STRIGGER == "NO") then			
				SOLO_LOOP = "NO";
				MYSAP = "NO";
				YES_SAP = "NO";
				FIGHT_BACK = "NO";
				COMBAT = "NO";
				LOOP_HOLD = "NONE";
				NEXT_LOOP_HOLD = "NONE";
				Hold_Target = "NONE";
--				DEFAULT_CHAT_FRAME:AddMessage( "COMBAT OFF" , 0.3, 1.0, 1.0 );
--				if not (UnitIsDead("target")) and UnitIsEnemy("player","target") and STRIGGER == "NO" then
--					ClearTarget();
--				end
				STRIGGER = "NO";
		elseif (event == EVENT_PLAYER_ENTER_COMBAT or event == EVENT_PLAYER_REGEN_DISABLED) and COMBAT == "NO" then 
				COMBAT = "YES";				
				if GetNumPartyMembers() > 0 and not (MAIN_ASSIST == "NONE") then
					AssistByName(MAIN_ASSIST);
				end
--				if UnitName("target") == nil or not (UnitAffectingCombat("target") == 1) then
--					RogueLogic_Target();
--				end
		end


	end
end

function RogueLogic_SlashCommandHandler( msg )

if UnitClass("player") == "Rogue" then

	local saphold;
	saphold = msg;
	msg = string.lower( msg );
	local text = msg;
	local a, b, c, n = string.find (msg, "(%w+) (.+)");
	local a1, b1, c1, n1 = string.find (saphold, "(%w+) (.+)");
	if (n == nil) then
		a, b, c = string.find (msg, "(%w+)");
	end
	
	if (c == "help") then
 		HelpUsage();
	end

	if (c == "autotarget") then
		if (n == "on") then
			AutoTargetSet(1);
		elseif (n == "off") then
			AutoTargetSet(0);
		else
			HelpUsage();		
		end 
	end

	if (c == "attack") then
		if (n == "on") then
			AutoAttackSet(1);
		elseif (n == "off") then
			AutoAttackSet(0);
		else
			HelpUsage();		
		end 
	end

	if (c == "debug") then
		if (n == "on") then
			DeBugSet(1);
		elseif (n == "off") then
			DeBugSet(0);
		else
			HelpUsage();		
		end 
	end

	if (c == "assist") then
		if not (n == nil) and not (n == "reset") then
			MAIN_ASSIST = n;
			ClearTarget();
			TargetByName(MAIN_ASSIST);
			if UnitCanAssist("player", "target") and string.lower (UnitName("target")) == MAIN_ASSIST then 
				DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic - Main Assist = " .. n1);
				ClearTarget();
				DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: use /rl assist reset to clear this unit", 1.0, 0.0, 0.0);
			else
				DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: Error Setting " .. n1 .. " As Assist!");
				DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: This Unit Might Not Be Within Range!");
				DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: Assiting This Unit Might Not Work!")
				DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: use /rl assist reset to clear this unit", 1.0, 0.0, 0.0);
				ClearTarget();
			end 
		elseif n == "reset" then
				DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic - Main Assist Removed");
				MAIN_ASSIST = "NONE";				
		else
			HelpUsage();		
		end 
	end

	if (c == "stop") then RL_Enabled = 0; end
	
	if (c == "enabled") then
		if (n == "on") then
			EnabledSet(1);
		elseif (n == "off") then
			EnabledSet(0);
		else
			HelpUsage();		
		end 
	end

	if (c == "sapannounce") then
		if (n == "on") then
			SapAnnounceSet(1);
		elseif (n == "off") then
			SapAnnounceSet(0);
		else
			HelpUsage();		
		end 
	end
	
	if (c == "setsapmsg") then
		DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic Set Sap Message:");
		DEFAULT_CHAT_FRAME:AddMessage("     /RogueLogic MSG1 <msg>");
		DEFAULT_CHAT_FRAME:AddMessage("     /RogueLogic MSG2 <msg>");
		DEFAULT_CHAT_FRAME:AddMessage("(Rogue Logic will provide the target)");
		DEFAULT_CHAT_FRAME:AddMessage("MSG1 = " .. RL_MSG1);
		DEFAULT_CHAT_FRAME:AddMessage("MSG2 = " .. RL_MSG2);
		DEFAULT_CHAT_FRAME:AddMessage("Either Msg Can Be NONE Example: /RogueLogic MSG1 none ");
		DEFAULT_CHAT_FRAME:AddMessage("Current: " .. RL_MSG1 .. " Vilebranch Scalper " .. RL_MSG2, 1.0, 0.0, 0.0);
	end

	if (c == "msg1") then
		if (n ~= nil) and not (n == "none") then
			RL_MSG1 = n1;
			DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: Message Part 1 set to << " .. RL_MSG1 .. " >>");
		elseif n == "none" then
			RL_MSG1 = " ";
		else
			HelpUsage();
		end
	end

	if (c == "channel") then
		if (n ~= nil) then
			if n == "auto" then
				RL_Channel = n;
				DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: Channel selection automatic");
			else
				local id = GetChannelName( n );
				if (id) then
					RL_Channel = n;
					DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: Channel set to << " .. n .. " >>");
				else
					RL_Channel = "auto";
					DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: Channel does not exist reset to auto");
				end
			end
		end
	end

	if (c == "msg2") then
		if (n ~= nil) then
			RL_MSG2 = n1;
			DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: Message Part 2 set to << " .. RL_MSG2 .. " >>");
		elseif n == "none" then
			RL_MSG2 = " ";
		else
			HelpUsage();
		end
	end	

	else
		DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic Not Enabled - This Char Not A Rogue!");	
	end

end

function RogueLogicPrint(msg)
	if (DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage(msg)
	end
end

function HelpUsage()

	if ( DEFAULT_CHAT_FRAME ) then
   		DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic Options:", 1.0, 0.0, 0.0);
		DEFAULT_CHAT_FRAME:AddMessage("/RogueLogic autotarget <on/off> (" .. RLOnOrOff(RL_AUTOTARGET) .. ")", 1.0, 1.0, 0.0);
		DEFAULT_CHAT_FRAME:AddMessage("/RogueLogic attack <on/off> (" .. RLOnOrOff(RL_Attack) .. ")", 1.0, 1.0, 0.0);
		DEFAULT_CHAT_FRAME:AddMessage("/RogueLogic enabled <on/off> (" .. RLOnOrOff(RL_Enabled) .. ")", 1.0, 1.0, 0.0);
		DEFAULT_CHAT_FRAME:AddMessage("/RogueLogic stop (quick shut shutoff of everything)", 1.0, 1.0, 0.0);
		DEFAULT_CHAT_FRAME:AddMessage("/RogueLogic assist <Main Assist name> (" .. MAIN_ASSIST .. ")", 1.0, 1.0, 0.0);
		DEFAULT_CHAT_FRAME:AddMessage("/RogueLogic debug <on/off> (" .. RLOnOrOff(RL_Debug).. ")", 1.0, 1.0, 0.0);
		DEFAULT_CHAT_FRAME:AddMessage("/RogueLogic setsapmsg", 1.0, 1.0, 0.0);
		DEFAULT_CHAT_FRAME:AddMessage("/RogueLogic sapannounce <on/off> (" .. RLOnOrOff(RL_Announce) .. ")", 1.0, 1.0, 0.0);
		DEFAULT_CHAT_FRAME:AddMessage("/RogueLogic channel <channel name> (" .. RL_Channel .. ")", 1.0, 1.0, 0.0);

	end
end

function AutoTargetSet(msg)
	if (msg == 1) then
		RL_AUTOTARGET = 1;
  		if ( DEFAULT_CHAT_FRAME ) then
   			DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: Auto Target Option On");
  		end
	else
		RL_AUTOTARGET = 0;
  		if ( DEFAULT_CHAT_FRAME ) then
   			DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: Auto Target Option Off");
  		end
 	end
end

function AutoAttackSet(msg)
	if (msg == 1) then
		RL_Attack = 1;
  		if ( DEFAULT_CHAT_FRAME ) then
   			DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: Auto Attack Option On");
  		end
	else
		RL_Attack = 0;
  		if ( DEFAULT_CHAT_FRAME ) then
   			DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: Auto Attack Option Off");
  		end
 	end
end


function EnabledSet(msg)
	if (msg == 1) then
		RL_Enabled = 1;
  		if ( DEFAULT_CHAT_FRAME ) then
   			DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: Program Enabled!");
  		end
	else
		RL_Enabled = 0;
  		if ( DEFAULT_CHAT_FRAME ) then
   			DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: Program Disabled");
  		end
 	end
end

function DeBugSet(msg)
	if (msg == 1) then
		RL_Debug = 1;
  		if ( DEFAULT_CHAT_FRAME ) then
   			DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: Debug Messages On!");
  		end
	else
		RL_Debug = 0;
  		if ( DEFAULT_CHAT_FRAME ) then
   			DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: Debug Messages Off");
  		end
 	end
end

function SapAnnounceSet(msg)
	if (msg == 1) then
		RL_Announce = 1;
  		if ( DEFAULT_CHAT_FRAME ) then
   			DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: Sap Announcement Enabled!");
  		end
	else
		RL_Announce = 0;
  		if ( DEFAULT_CHAT_FRAME ) then
   			DEFAULT_CHAT_FRAME:AddMessage("Rogue Logic: Sap Announcement Disabled");
  		end
 	end
end

function RLOnOrOff(bool)
	if (bool == 1) then
		return "on";
	end
	return "off";
end


--=================================================================================